<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';
import { LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { assemblePageContent } from '~/services/free-trial/devops.service';
import { CustomerLogos } from '~/components/home/index.vue';
import {
  FreeTrialAccolades as Accolades,
  FreeTrialBlock as Block,
  FreeTrialHero as Hero,
  FreeTrialNextSteps as NextSteps,
  FreeTrialSquares as Squares,
} from '~/components/free-trial/index.vue';

export default Vue.extend({
  name: 'FreeTrial',
  components: {
    Hero,
    Accolades,
    Squares,
    NextSteps,
    Block,
    CustomerLogos,
  },
  mixins: [LivePreviewMixin],
  layout: 'free-trial-navigation',
  async asyncData({ i18n }: any) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': `free-trial/devops`,
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const { pageContent } = items[0].fields;

      const data = assemblePageContent(pageContent);
      const metadata = items[0].fields.seoMetadata[0].fields;
      return { data, metadata, items };
    } catch (e) {
      throw new Error(e);
    }
  },
  nuxtI18n: {
    locales: ['ja-jp'],
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items[0].fields,
        callback: (updatedData) =>
          (this.data = assemblePageContent(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div class="devops">
    <component
      :is="component.name"
      v-for="component in data.components"
      :key="component.name"
      :data="component.data"
    />
  </div>
</template>
<style scoped lang="scss">
.devops {
  :deep {
    .content-cards-heading {
      padding-top: $spacing-96;

      @media (max-width: $breakpoint-md) {
        padding-top: $spacing-64;
      }
      + .content-cards {
        padding-top: 0;
        :nth-child(even) {
          padding-right: 0;
        }

        :nth-child(odd) {
          padding-left: 0;
        }
      }
    }
    .hero {
      padding-bottom: 64px;
      .header {
        h1 {
          @media (min-width: $breakpoint-md) {
            font-size: 50px;
            line-height: 60px;
            margin-bottom: 24px;
          }
        }
      }
    }
    .customer-logos {
      position: relative;
      background-color: $color-surface-800;
      padding: 48px 0;
      margin-bottom: 0;

      @media (min-width: $breakpoint-lg) {
        padding: 96px 0;
      }
      .customer-logos__companies {
        width: 100%;
        margin: 0 auto;
        @media (min-width: 640px) {
          max-width: 95%;
        }

        @media (min-width: 1024px) {
          max-width: 1024px;
          padding: 0px;
        }

        @media (min-width: 1170px) {
          max-width: 1170px;
          padding: 0px;
        }
      }
    }
  }
}
</style>
